#! /usr/bin/perl 
#/usr/local/bin/perl
#
# Tenki multi Getter
# For Tamabi
# H.Miyazawa
# 2004/07/31
#
# jcode
require './jcode.pl';

#HostName
$HostName = "tenki.jp";
$Agent = "Mondrian";
$file_out = "./tenki.txt";

&get_date;
$get_date_last = $min;

#AreaCodeMulti
@areacodemulti = ('14',
	'34',
	'54',
	'44',
	'51',
	'62',
	'67',
	'74',
	'82',
	'91');
# Sapporo, Sendai, Niigata, Tokyo, Nagoya, Osaka, Hiroshima, Kochi, Fukuoka,Naha

# AreaCodeNow
# 20-99
$areacodenow = @ARGV[0];
if( $areacodenow !~ m/[0-9]+/ ){
	$areacodenow = 44;
}
if($areacodenow < 1) {
	$areacodenow = 44;
}
if($areacodenow < 9) {
	$areacodenow = "0$areacodenow";
}
if($areacodenow > 100){
	$areacodenow = 44;
}
$Path = "/yoh/y$areacodenow.html";
#print("AreaCode:$areacode\n");
print("URL:http://$HostName$Path\n");

#interval
$interval_time = @ARGV[1];
if( $interval_time !~ m/[0-9]+/ ){
	$interval_time = 0
}
if($interval_time > 60){
	$interval_time = 60;
}
print("IntervalTime : $interval_time (min.)\n");
&main_loop;

sub main_loop{
&main;
if($interval_time == 0){
	print ("END\n");
	exit;
}
while(1){
	# sec
	sleep 10;
	&get_date;
	$time_i = $get_date_last + $interval_time;
	if($time_i > 60){
		$time_i = $time_i -60;
	}
	if($min == $time_i ){
		print "\n";
		&main;
		$get_date_last = $min
	}else{
		#print "$min $get_date_last $time_i\n";
		#printf ".";
	}
}

}#end sub mail_loop

sub main{
my $file_m_i;
$file_out = "./tenki.txt";
$areacode = $areacodenow;
$Path = "/yoh/y$areacode.html";
	&httpget;
	&tenki;
	&tenki_file_out;

for($file_m_i = 0; $file_m_i < 10; $file_m_i++){
	sleep 1;
	$file_out = "./$file_m_i.txt";
	# print("$file_out\n");
	$areacode = $areacodemulti[$file_m_i];
	$Path = "/yoh/y$areacode.html";
	print("URL:http://$HostName$Path => $file_out\n");
	&httpget;
	&tenki;
	&tenki_file_out;
}
}# end of main

sub tenki_file_out{
my $i;
my $out_line = "";
#open(OUT,">$file_out");
my $t_y; #todat=0
#$hour = 13;
#print "$hour $mday 1:$tenki_hiduke[1] 2:$tenki_hiduke[2] \n";
if ($hour<12){
	#Select TODAY
	if($mday  == $tenki_hiduke[1]){
		$t_y = 0;
	}else{
		$t_y = 1;
	}
}else{
	#Select ASU
	if($mday + 1 == $tenki_hiduke[1]){
		$t_y = 0;
	}else{
		$t_y = 1;
	}
}

#if ($hour<12){
#	$t_y = 0;
#}else{
#	$t_y = 1;
#} 
#TENKI -------
if (0 + $tenki_flag[$t_y] & 1){
	$i = 1;
}else{
	$i = 0;
}
#print OUT "$i&";
$outline = "hare=$i";

#print OUT "kumori=";
if (0 + $tenki_flag[$t_y] & 2){
	$i = 1;
}else{
	$i = 0;
}
#print OUT "$i&";
$outline = "$outline&kumori=$i";

#print OUT "ame=";
if (0 + $tenki_flag[$t_y] & 4){
	$i = 1;
}else{
	$i = 0;
}
#print OUT "$i&";
$outline = "$outline&ame=$i";

#print OUT "yuki=";
if (0 + $tenki_flag[$t_y] & 8){
	$i = 1;
}else{
	$i = 0;
}
#print OUT "$i&";
$outline = "$outline&yuki=$i";

#KION
#print OUT "kion=$kion_flag[$t_y]&";
$outline = "$outline&kion=$kion_flag[$t_y]";

#KOSUI
#print OUT "kosui=$kosui_flag[8+$t_y]";
$outline = "$outline&kousi=$kosui_flag[8+$t_y]&kosui=$kosui_flag[8+$t_y]";


open(OUT,">$file_out");
print OUT "$outline";
print OUT "&dummy=0\n";
close(OUT);
print "$t_y $outline\n";

}# end sub tenki_file_out


sub tenki{
#TENKI
#1:hare 2:kumori 4:ame 8:yuki
$tenki_flag[0] = 0; #today
$tenki_flag[1] = 0; #yeaterday
my $tenki_flag_i = 0;
$kion_flag[0] = 0; #todat
$kion_flag[1] = 0; #yeasterday
my $kion_flag_i = 0;
my $kosui_flag_i = 0;
for($kosui_flag_i=0;$kosui_flag_i<=9;$kosui_flag_i++){
	$kosui_flag[$kosui_flag_i] = -10;
}
$kosui_flag_i = 0;
$kosui_am6 = 0;

my $line_i = 0;
# MOJICODE
my $strmax = "ō"; #saikou
&jcode::convert(\$strmax, 'euc');
my $strdo = ""; #do
&jcode::convert(\$strdo, 'euc');
my $stryoko = "|";#yokobou
&jcode::convert(\$stryoko, 'euc');
my $strji = ""; #toki
&jcode::convert(\$strji, 'euc');
my $strpa = ""; #parsent
&jcode::convert(\$strpa, 'euc');
my $strhidu = "t"; #hiduke
&jcode::convert(\$strhidu, 'euc');
my $strkakko = "i"; #migikakko
&jcode::convert(\$strkakko, 'euc');

foreach $line(@html_line){
	my $flag = 0;
	#TENKI
	$flag = index $line, "mark/";
	if($flag > 0){
		my $line_t = substr($line, $flag + 5);
		$flag = index $line_t, "gif";
		$line_t = substr($line_t ,0 , $flag - 1);
		$tenki_flag[$tenki_flag_i] = $line_t;
		$tenki_flag_i++;
	}
	#MAX KION
	$flag = index $line, $strmax;
	if($flag > 0){
		for($j=1; $j<=2;$j++){
		$flag = index $html_line[$line_i + $j], "2200>";
		my $line_t = substr($html_line[$line_i + $j], $flag + 5);
		$flag = index $line_t, $strdo;
		#no MAX
		if($flag < 0){
			$line_t = 100;
		}else{
			$line_t = substr($line_t ,0 , $flag);
		}
		$kion_flag[$kion_flag_i] = $line_t;
		$kion_flag_i++;
		#print "$line_t\n";
		}
	}
	#KOSUI
	$flag = index $line, $strji;
	$flag2 = index $line, $stryoko;
	if($flag > 0){
	if($flag2 > 0){
	for($j=1; $j<=2;$j++){
		$flag = index $html_line[$line_i + $j], "6600";
		if($flag < 0){
			$flag = 0;
		}
		my $line_t = substr($html_line[$line_i + $j], $flag + 6);
		$flag = index $line_t, $strpa;
		if($flag >= 0){
			$line_t = substr($line_t ,0 , $flag);
			$kosui_flag[$kosui_flag_i] = $line_t;
		}	
		#$kosui_flag[$kousi_flag_i] = $line_t;
		#print "K $kosui_flag_i $line_t\n";
		$kosui_flag_i++;
	}
	}
	}
	#HIDUKE
	$flag = index $line, $strhidu;
	$flag2 = index $line, "100";
	if($flag > 0){
	if($flag2 > 0){
	for($j=1; $j<=2;$j++){
		$flag = index $html_line[$line_i + $j], "color";
		if($flag < 0){
			$flag = 0;
		}
		my $line_t = substr ($html_line[$line_i + $j], $flag + 5);
		$flag = index $line_t, ">";
		if($flag < 0){
			$flag = 0;
		}
		$line_t = substr ($line_t, $flag + 1);
		$flag = index $line_t, $strkakko;
		if($flag < 0){
			$flag = 0;
		}
		$line_t = substr ($line_t,0, $flag );
		$line_t =~ s/ //;
		$tenki_hiduke[$j] = $line_t;
		#printf("$line_t\n");
	}
	}}

	#am6
	#$flag = index $html_line[2], "rowSpan=4";
	#if($flag >= 0){
	#	$kosui_am6 = 1;
	#}
	
	#}
$line_i++;
}


for($j=0; $j<=1;$j++){
	my $flag_j = 0;
	$flag = index $tenki_flag[$j], "a";
	if($flag >= 0){$flag_j = $flag_j + 1;}
	$flag = index $tenki_flag[$j], "b";
	if($flag >= 0){$flag_j = $flag_j + 2;}
	$flag = index $tenki_flag[$j], "c";
	if($flag >= 0){$flag_j = $flag_j + 4;}
	$flag = index $tenki_flag[$j], "d";
	if($flag >= 0){$flag_j = $flag_j + 8;}

	$tenki_flag[$j] = $flag_j;
#	print("TENKI:$tenki_flag[$j]\n");
#	print("KION:$kion_flag[$j]\n");
}
#kosui 8,9 ave
$kosui_flag[8] = 0;
$kosui_flag[9] = 0;
my $i8 = 0;
my $i9 = 0;
for($j=0; $j<=3;$j++){
#	print("kosui:$kosui_flag[$j*2] $kosui_flag[$j*2 + 1]\n");
	if($kosui_flag[$j*2] >= 0){
		$kosui_flag[8] =$kosui_flag[8] + $kosui_flag[$j*2];
		$i8++;	
	}
	if($kosui_flag[$j*2+1] >= 0){
		$kosui_flag[9] = $kosui_flag[9] + $kosui_flag[$j*2+1];
		$i9++;	
	}
}
$kosui_flag[8] = $kosui_flag[8] / $i8;
$kosui_flag[9] = $kosui_flag[9] / $i9;
#print "$kosui_flag[8] $i8  $kosui_flag[9] $i9\n";
#print "kosui_am6:$kosui_am6\n";
}# end sub tenki

sub httpget{
	#Open Socket
	my $Port = 80;
#	$Path = "/axis-cgi/mjpg/video.cgi";
#	$Path = "/yoh/y44.html";
#	$Path = "\/$rdpath";
	$addr = (gethostbyname($HostName))[4];
#	print "Conect to $HostName\n";
#	print "\n<BR>";
	if (!$addr){
		&error("$HostName Server Not Found");
	}
	#
	$name = pack("S n a4 x8", 2, $Port, $addr);
	$proto = getprotobyname('tcp');
	socket(SOCK, 2, 1, $proto) or &error("Can not open SOCKET");
	connect(SOCK, $name) or &error("$HostName Contect miss");
	binmode(SOCK);
	select(SOCK); $| = 1; select(STDOUT);
	
	#
	$PostData = $buffur_POST;
	if ($PostData){
		$Method = "POST";
	} else {
		$Method = "GET";
	}
			if ($Port == 80){
				$port = "";
			} else {
				$port = ":$Port";
			}
			#HTTP 1.1 GET/POST
			print SOCK "$Method $Path HTTP/1.1\r\n";
			print SOCK "Accept: */*\r\n";
			#print SOCK "Accept: text/*\r\n";
			print SOCK "User-Agent: $Agent\r\n";
			print SOCK "Host: $HostName$port\r\n";
			#Pssword
			print SOCK "Authorization: Basic c2lpb2xhYjpzaWlvbGFi\r\n";
			print SOCK "Connection: close\r\n";
			print SOCK "\r\n";
			if ($PostData){
				$size = length($PostData);
				print SOCK "Accept-Ranges: bytes\r\n";
				print SOCK "Content-Length: $size\r\n";
			}
			print SOCK "\r\n";
			if ($PostData){
				print SOCK "$PostData";
				$PostData = "";
			}


		#Read Header
		$line = <SOCK>;
		if ($line =~ /404/){
			&error("$HostName$Path 404");
		} elsif ($line =~ /403/){
			&error("$HostName$Path 403");
		}
		if (eof(SOCK)){	&error("$HostName Close");	}

		$line_head = 1;
		$html = 0;
		$ImgFile = "./htmlimg.txt";
		my $html_i = 0;
		while ($line = <SOCK>){
			$line2 = $line;
			$line2 =~ s/\x0D|\x0A//g;	#CR
			if ($line_head){
				if (!$line2){
					# print "\n";
					#binmode STDOUT;
					$line_head = 0;
					open(OUT,">$ImgFile")
					# or &error("");
					# file open 
					# binmode OUT;
					# binmode STDOUT;
				}else{
					if($line2 =~ /^Content-Type:.*/i){
						if($line2 =~ /text\/*/i){
							$html = 1;
							#print "$line2\n";
						# }else{
							# print "$line2\n";
							# print "Content-Type: text/html\n";
							#&error("");
						}
					}
				}
			}else{
				# print "$line";
				#print OUT "$line";
				print OUT "$line2\n";
				@html_line[$html_i] = "$line2";
				$html_i = $html_i + 1;
			}
		}
	close(OUT);
	close(SOCK);
	# chmod (0666,$ImgFile);
	# if($html){print "\n<!-- $HostName$Path -->\n";}
	# 
	# system("./rejpeg $ImgFile $ImgDir2$no$tail $key");
	#$Imgkey = "0.188";
	# system("./rejpeg $ImgFile $ImgFilei $Imgkey");

}#end of httpget

# ERROR #
sub error{
close(SOCK);
print <<"EOM";
Error @_
EOM
exit;
}#end sub error

sub get_date{
        ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time);
        #return sprintf("%04d%02d%02d-%02d%02d%02d",
         #                   $year+1900,$mon+1,$mday,$hour,$min,$sec);
}


